unit msScadau;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, SynEdit, SerialPort, ModBusSerial, PLCBlock,
  PLCBlockElement, HMICheckBox, HMIAnimation, HMILabel, HMIText, HMIEdit, Forms,
  Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, Buttons, commtypes, Tag,
  TagBit, PLCTagNumber, PLCStructElement, HMITypes, hmicolorpropertyconnector,
  HMIComboBox;

type

  { TForm1 }

  TForm1 = class(TForm)
    btWRconf: TBitBtn;
    cbPort: TComboBox;
    GroupBox1: TGroupBox;
    gbStepMode: TGroupBox;
    gbPoss: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    gbSpeeds: TGroupBox;
    gbCurrents: TGroupBox;
    hedMinspeed: THMIEdit;
    hedCurrhold: THMIEdit;
    HMIColorPropertyConnector1: THMIColorPropertyConnector;
    HMIColorPropertyConnector10: THMIColorPropertyConnector;
    HMIColorPropertyConnector11: THMIColorPropertyConnector;
    HMIColorPropertyConnector2: THMIColorPropertyConnector;
    HMIColorPropertyConnector3: THMIColorPropertyConnector;
    HMIColorPropertyConnector4: THMIColorPropertyConnector;
    HMIColorPropertyConnector5: THMIColorPropertyConnector;
    HMIColorPropertyConnector6: THMIColorPropertyConnector;
    HMIColorPropertyConnector7: THMIColorPropertyConnector;
    HMIColorPropertyConnector8: THMIColorPropertyConnector;
    HMIColorPropertyConnector9: THMIColorPropertyConnector;
    HMIComboBox1: THMIComboBox;
    hedMaxSpeed: THMIEdit;
    hedAccel: THMIEdit;
    hedDecel: THMIEdit;
    hedCurrRun: THMIEdit;
    hedCurrAcc: THMIEdit;
    hedCurrDec: THMIEdit;
    HMIEdit9: THMIEdit;
    Image1: TImage;
    Image10: TImage;
    Image11: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    Image9: TImage;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    lSTPercOK: TLabel;
    lSTCommErrors: TLabel;
    lSTPortStatus: TLabel;
    lLog2: TLabel;
    lLog1: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    Label55: TLabel;
    Label56: TLabel;
    Label6: TLabel;
    Label63: TLabel;
    Label64: TLabel;
    Label65: TLabel;
    Label66: TLabel;
    Label67: TLabel;
    Label68: TLabel;
    Label69: TLabel;
    Label70: TLabel;
    Label71: TLabel;
    Label72: TLabel;
    lLog3: TLabel;
    Panel1: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel2: TPanel;
    hedMark: THMIEdit;
    hedPos: THMIEdit;
    hedPreset: THMIEdit;
    hedPulseP: THMIEdit;
    hedPulseM: THMIEdit;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label2: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label3: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label4: TLabel;
    lOcdText: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    lOcd: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    pbIns: TPLCBlock;
    pbIns_word1_bit1: TTagBit;
    pbIns_word1_bit10: TTagBit;
    pbIns_word1_bit11: TTagBit;
    pbIns_word1_bit2: TTagBit;
    pbIns_word1_bit3: TTagBit;
    pbIns_word1_bit4: TTagBit;
    pbIns_word1_bit5: TTagBit;
    pbIns_word1_bit6: TTagBit;
    pbIns_word1_bit7: TTagBit;
    pbIns_word1_bit8: TTagBit;
    pbIns_word1_bit9: TTagBit;
    pbOuts_word1_e1: TTagBit;
    pbOuts_word1_e10: TTagBit;
    pbOuts_word1_e11: TTagBit;
    pbOuts_word1_e12: TTagBit;
    pbOuts_word1_e13: TTagBit;
    pbOuts_word1_e14: TTagBit;
    pbOuts_word1_e15: TTagBit;
    pbOuts_word1_e16: TTagBit;
    pbOuts_word1_e2: TTagBit;
    pbOuts_word1_e3: TTagBit;
    pbOuts_word1_e4: TTagBit;
    pbOuts_word1_e5: TTagBit;
    pbOuts_word1_e6: TTagBit;
    pbOuts_word1_e7: TTagBit;
    pbOuts_word1_e8: TTagBit;
    pbOuts_word1_e9: TTagBit;
    pbIns_word1: TPLCBlockElement;
    plcCurrents_e1: TPLCBlockElement;
    plcCurrents_e2: TPLCBlockElement;
    plcCurrents_e3: TPLCBlockElement;
    plcCurrents_e4: TPLCBlockElement;
    plcPosRegs: TPLCBlock;
    plcSpeeds: TPLCBlock;
    plcPosRegs_e0: TPLCBlockElement;
    plcPosRegs_e1: TPLCBlockElement;
    plcPosRegs_e2: TPLCBlockElement;
    plcCurrents: TPLCBlock;
    plcStepMode: TPLCBlock;
    plcSpeeds_e1: TPLCBlockElement;
    plcSpeeds_e2: TPLCBlockElement;
    plcSpeeds_e3: TPLCBlockElement;
    plcSpeeds_e4: TPLCBlockElement;
    plcWConf: TPLCBlock;
    plcStepMode_Conf: TPLCBlockElement;
    plcStepMode_Conf_bit12: TTagBit;
    plcStepMode_Spd: TPLCBlockElement;
    plcWConf_e0: TPLCBlockElement;
    plcWConf_e0_bit2: TTagBit;
    ptPulseP: TPLCTagNumber;
    ptPulseM: TPLCTagNumber;
    tmInRead: TTimer;
    Ygohome1: THMIAnimation;
    Yhiz: THMIAnimation;
    Yrelsw1: THMIAnimation;
    Yrelsw2: THMIAnimation;
    Yrelsw3: THMIAnimation;
    Yrunm: THMIAnimation;
    Yrunp2: THMIAnimation;
    Yrunp3: THMIAnimation;
    Ystop2: THMIAnimation;
    Ystop3: THMIAnimation;
    Ystpdir: THMIAnimation;
    Ystop: THMIAnimation;
    ModBusRTUDriver1: TModBusRTUDriver;
    pnTop: TPanel;
    pbOuts: TPLCBlock;
    pbOuts_word1: TPLCBlockElement;
    SerialPortDriver1: TSerialPortDriver;
    Yrunp: THMIAnimation;
    Yswminus1: THMIAnimation;
    Yocd: THMIAnimation;
    procedure btWRconfClick(Sender: TObject);
    procedure cbPortDropDown(Sender: TObject);
    procedure cbPortSelect(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure hedPresetEnter(Sender: TObject);
    procedure hedPulsePKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure pbInsValueChange(Sender: TObject);
    procedure plcPosRegsUpdate(Sender: TObject);
    // procedure pbIns_word1_bit4AsyncValueChange(Sender: TObject; const Value: TArrayOfDouble);
    procedure tmInReadTimer(Sender: TObject);
    procedure YstopClick(Sender: TObject);
    procedure SerialPortDriver1CommErrorReading(Error: TIOResult);
    procedure SerialPortDriver1CommErrorWriting(Error: TIOResult);
    procedure LogOnce(st: string);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation
Uses registry;

{$R *.lfm}

{ TForm1 }

procedure TForm1.YstopClick(Sender: TObject);
begin
  with THMIAnimation(sender) do begin
    if PLCTag=NIL then exit;
    TTagBit(PLCTag).Value := 1-TTagBit(PLCTag).Value ;
  end;
  tmInRead.Enabled := true;
end;


procedure TForm1.hedPresetEnter(Sender: TObject);
begin
  THMIEdit(sender).Modified := true;
end;

procedure TForm1.LogOnce(st: string);
begin
  lLog1.Caption := lLog2.Caption;
  lLog2.Caption := lLog3.Caption;
  lLog3.Caption := st;
end;

procedure TForm1.btWRconfClick(Sender: TObject);
begin
  if MessageDlg('Ministep M3', 'Want to save the current values?', mtConfirmation, mbYesNo, '')<>mrYes then begin
    LogOnce('Declined save');
    exit
  end;
  plcWConf_e0_bit2.Value := 1;
  Application.MessageBox('Configuration saved', 'Ministep M3', 0);
  LogOnce('Configuration saved');
end;

procedure TForm1.cbPortDropDown(Sender: TObject);
var
  i			: integer;
  reg		: TRegistry;
  comports	: TStringList;
  names		: TStringList;

begin
  reg := Tregistry.Create;
  reg.RootKey := HKEY_LOCAL_MACHINE;
  reg.OpenKeyReadOnly('\hardware\devicemap\serialcomm');
  comports := TStringList.Create;
  names := TStringList.Create;
  reg.GetValueNames(names);
  cbPort.Clear;
  for i := 0 to names.Count-1 do cbPort.Items.Add(reg.ReadString(names[i]));

  comports.Free;
  names.Free;
end;

procedure TForm1.cbPortSelect(Sender: TObject);
begin
  SerialPortDriver1.Active := false;
  pbOuts.ResetStatsCounters;
  SerialPortDriver1.COMPort := cbPort.Text;
  SerialPortDriver1.Active := true;
  LogOnce('Open port: '+SerialPortDriver1.LastOSErrorMessage);
  lSTPortStatus.Caption := 'Open port OS error: '+inttostr(SerialPortDriver1.LastOSErrorNumber);
  if SerialPortDriver1.LastOSErrorNumber=0 then begin
    plcSpeeds.Read;
    plcCurrents.Read;
    plcStepMode.Read;
  end;
end;

function oneofparis(st: string): boolean;
var
  i		: integer;

begin
  result := false;
  for i := 1 to ParamCount
	do if ParamStr(i)=st then result := true
end;


function GetSysColor(index: integer): cardinal; stdcall; external 'user32.dll';

procedure TForm1.FormShow(Sender: TObject);
var
  cl	: TColor;

begin
  cl := GetSysColor(15) + $101010;	// btn_face
  // Application.MessageBox(PChar(format('%x', [cl])), 'Col', 0);
  if (cl and $FFFFFF<>0) and (cl and $FF000000=0) then begin
    GroupBox1.Color := cl;
    GroupBox4.Color := cl;
  end;

  if not oneofparis('/OCD') then begin
    Yocd.Visible := false;
    lOcd.Visible:=false;
    lOcdText.Visible:=false;
  end;

  pbIns.read;
  pbOuts.Read;
end;

procedure TForm1.hedPulsePKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  THMIEdit(sender).Modified := true
end;

procedure TForm1.pbInsValueChange(Sender: TObject);
begin
  gbStepMode.Enabled := pbIns_word1_bit8.Value=1;
  lSTCommErrors.Transparent:=true;

  if pbIns_word1_bit3.Value = 0
    then plcPosRegs.RefreshTime := 200	// non stop
    else plcPosRegs.RefreshTime := 2000	// non stop
end;

procedure TForm1.plcPosRegsUpdate(Sender: TObject);
var
  errs	: integer;
  wrok	: real;

begin
  errs := pbOuts.CommReadErrors+pbOuts.CommWriteErrors;
  lSTCommErrors.Caption := 'Comm errors: '+inttostr(errs);
  wrok := pbOuts.CommReadsOK+pbOuts.CommWritesOk;
  if wrok<>0
    then wrok := errs / wrok * 100;
  lSTPercOK.Caption := 'Comm error rate: '+Format('%3.1f%%', [wrok]);
end;

(*
procedure TForm1.pbIns_word1_bit4AsyncValueChange(Sender: TObject;
  const Value: TArrayOfDouble);
begin
  // seMemo.Lines.add('X4 async change: '+FloatToStr(pbIns_word1_bit4.Value));
end;
*)

procedure TForm1.tmInReadTimer(Sender: TObject);
begin
  tmInRead.Enabled := false;
  pbOuts.Read;
  pbIns.Read;
  // seMemo.Lines.add('X4='+FloatToStr(pbIns_word1_bit4.Value)+'  Y3='+FloatToStr(pbOuts_word1_e4.Value));
end;

procedure TForm1.SerialPortDriver1CommErrorReading(Error: TIOResult);
begin
  LogOnce(inttostr(GetTickCount)+' error reading');
  lSTCommErrors.Color:= clRed;
end;

procedure TForm1.SerialPortDriver1CommErrorWriting(Error: TIOResult);
begin
  LogOnce(inttostr(GetTickCount)+' error writing');
  lSTCommErrors.Color:= clRed;
end;

end.

